;;;======================================================
;;;     Lunochod V 1.0.0
;;;     MISSION Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

(defmodule MISSION (export deftemplate ?ALL) (import MAIN deftemplate ?ALL) (import SIMULATOR deftemplate ?ALL))

(deftemplate MISSION::command                   ;   ,    
 (slot name)
 (slot param (type INTEGER) (default 0))
)

(deftemplate MISSION::answer                    ;   ,    EXECUTOR
 (slot name)
 (slot param)
)

(deffacts MISSION::mission1-facts               ;     .
 (phase forward1)
)

;;;======================================================

(defrule MISSION::Mission1-Forward1             ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission mission1)
 ?m <- (phase forward1)
  =>
 (retract ?m)
 (printout t "MISSION::Mission1.Command.Forward1(5)" crlf)
 (assert (command (name forward) (param 5)))    ;   SOLVER
 (assert (phase right1))
)

(defrule MISSION::Mission1-Right1               ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission mission1)
 ?m <- (phase right1)
 ?n <- (answer (name forward) (param OK))
  =>
 (retract ?m)
 (retract ?n)
 (printout t "MISSION::Mission1.Command.Right1(3)." crlf)
 (assert (command (name right) (param 3)))      ;   SOLVER
 (assert (phase left1))
)

(defrule MISSION::Mission1-Left1                ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission mission1)
 ?m <- (phase left1)
 ?n <- (answer (name right) (param OK))
  =>
 (retract ?m)
 (retract ?n)
 (printout t "MISSION::Mission1.Command.Left1(8)." crlf)
 (assert (command (name left) (param 8)))       ;   SOLVER
 (assert (phase end1))
)

(defrule MISSION::Mission1-End1                 ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission mission1)
 ?m <- (phase end1)
 ?n <- (answer (name left) (param OK))
  =>
 (retract ?m)
 (retract ?n)
 (retract ?f)
 (printout t "MISSION::Mission1.Command.End()." crlf)
 (halt)
)