;;;======================================================
;;;     Lunochod V 1.0.0
;;;     EXECUTOR Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

(defmodule SOLVER (export deftemplate ?ALL) (import MAIN deftemplate ?ALL) (import MISSION deftemplate ?ALL) (import SENSOR deftemplate ?ALL))

(deftemplate SOLVER::action         ;   ,    EXECUTOR
 (slot name)                        ;  .
 (slot param)                       ;  .
 (slot status)                      ;  .
)

;;;======================================================

(defrule SOLVER::Decision-Motion-Start
 ?c <- (cycle ?current-cycle)
 ?f <- (sensor nobarrier)
 ?n <- (command (name ?motion) (param ?p))
  =>
 (retract ?f)
 (retract ?n)
 (printout t "SOLVER::" ?motion ".Start()." crlf)
 (assert (action (name ?motion) (param (- ?p 1)) (status request)))         ;   EXECUTOR
)

(defrule SOLVER::Decision-Motion-Cycle
 ?c <- (cycle ?current-cycle)
 ?f <- (sensor nobarrier)
 ?n <- (action (name ?motion) (param ?p) (status OK))
  =>
 (retract ?f)
 (retract ?n)
 (if (> ?p 0)
   then
    (printout t "SOLVER::" ?motion ".Continue()." crlf)
    (assert (action (name ?motion) (param (- ?p 1)) (status request)))       ;   EXECUTOR
   else
    (printout t "SOLVER::" ?motion ".End()." crlf)
    (assert (answer (name ?motion) (param OK)))             ;   MISSION
  )
)
 